stages:
  - test 
  - build-docker
  - test-docker
  - pages

test dev: &template_job
  when: manual
  stage: test
  image: python:3.7
  tags:
    - ada
    - docker
  before_script:
    - pip install -r requirements.txt
  script:
    - python manage.py test

test prod:
  variables:
    MYSQL_DATABASE: "vapordb"
    MYSQL_USER: "vaporuser"
    MYSQL_PASSWORD: "vaporpass"
    MYSQL_ROOT_PASSWORD: "rootpass"
    DJANGO_SETTINGS_MODULE: "vapormap.settings.production"
    VAPOR_DBHOST: "mariadb"
  services:
    - mariadb:10.3.17
  <<: *template_job

api tests:
  <<: *template_job
  script:
    - pip install requests
    - python manage.py test api.api_test.APITests

build docker images:
  stage: build-docker
  image: docker
  services:
    - docker:dind
  tags:
    - ada
    - docker
    - dind
  when: manual
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -f docker/Dockerfile.vapormap -t $CI_REGISTRY_IMAGE/vapormap:$CI_COMMIT_REF_NAME .
    - docker build -f docker/Dockerfile.nginx -t $CI_REGISTRY_IMAGE/nginx:$CI_COMMIT_REF_NAME .
    - docker push $CI_REGISTRY_IMAGE/vapormap:$CI_COMMIT_REF_NAME
    - docker push $CI_REGISTRY_IMAGE/nginx:$CI_COMMIT_REF_NAME



